<?php

/**
 * @file
 * Implementation of admin settings().
 */
function confident_captcha_admin_settings() {
  $form = array();
  $form['confident_captcha_customer_id'] = array(
    '#type' => 'textfield',
    '#title' => t('Customer ID'),
    '#default_value' => variable_get('confident_captcha_customer_id', ''),
    '#maxlength' => 40,
    '#description' => t('The Customer ID given to you when you <a href="@url" target="_blank">registered at login.confidenttechnologies.com</a>.', array('@url' => url('https://login.confidenttechnologies.com'))),
    '#required' => TRUE,
   );
  $form['confident_captcha_site_id'] = array(
    '#type' => 'textfield',
    '#title' => t('Site ID'),
    '#default_value' => variable_get('confident_captcha_site_id', ''),
    '#maxlength' => 40,
    '#description' => t('The SiteID given to you when you <a href="@url" target="_blank">registered at login.confidenttechnologies.com</a>.', array('@url' => url('https://login.confidenttechnologies.com'))),
    '#required' => TRUE,
  );
  $form['confident_captcha_api_username'] = array(

    '#type' => 'textfield',
    '#title' => t('API username'),
    '#default_value' => variable_get('confident_captcha_api_username', ''),
    '#maxlength' => 40,
    '#description' => t('The API username given to you when you <a href="@url" target="_blank">registered at login.confidenttechnologies.com</a>.', array('@url' => url('https://login.confidenttechnologies.com'))),
    '#required' => TRUE,
   );
  $form['confident_captcha_api_password'] = array(
    '#type' => 'textfield',
    '#title' => t('API password'),
    '#default_value' => variable_get('confident_captcha_api_password', ''),
    '#maxlength' => 40,
    '#description' => t('The API password given to you when you <a href="@url" target="_blank">registered at login.confidenttechnologies.com</a>.', array('@url' => url('https://login.confidenttechnologies.com'))),
    '#required' => TRUE,
  );

  $form['confident_captcha_theme_settings'] = array(
    '#type' => 'fieldset',
    '#title' => t('Confident CAPTCHA Settings'),
    '#collapsible' => TRUE,
  );

    $form['confident_captcha_theme_settings']['confident_captcha_color'] = array(
        '#type' => 'select',
        '#title' => t('Captcha Color'),
        '#description' => t('Color of the Confident CAPTCHA.'),
        '#options' => array(
            'Pearl' => t('Pearl'),
            'Black' => t('Black'),
            'Tangerine' => t('Tangerine'),
            'Pink' => t('Pink'),
            'Purple' => t('Purple'),
            'Orange' => t('Orange'),
            'Yellow' => t('Yellow'),
            'Aqua' => t('Aqua'),
            'Green' => t('Green'),
            'Red' => t('Red'),
        ),
        '#default_value' => variable_get('confident_captcha_color', 'Pearl'),
    );

  $form['confident_captcha_theme_settings']['confident_captcha_grid_color'] = array(
    '#type' => 'select',
    '#title' => t('Image Code Color'),
    '#description' => t('Color of the round background behind the characters on the Confident CAPTCHA.'),
    '#options' => array(
      'Red' => t('Red'),
      'White' => t('White'),
      'Orange' => t('Orange'),
      'Yellow' => t('Yellow'),
      'Green' => t('Green'),
      'Teal' => t('Teal'),
      'Blue' => t('Blue'),
      'Indigo' => t('Indigo'),
      'Violet' => t('Violet'),
      'Gray' => t('Gray'),
    ),
    '#default_value' => variable_get('confident_captcha_grid_color', 'Blue'),
  );

  $form['confident_captcha_theme_settings']['confident_captcha_grid_height'] = array(
    '#type' => 'textfield',
    '#title' => t('Grid Height'),
    '#maxlength' => 2,
    '#default_value' => variable_get('confident_captcha_grid_height', 3),
    '#description' => t('Height of the Confident CAPTCHA in images. Width multiplied by height may not exceed 16.'),
  );

  $form['confident_captcha_theme_settings']['confident_captcha_grid_width'] = array(
    '#type' => 'textfield',
    '#title' => t('Grid Width'),
    '#maxlength' => 2,
    '#default_value' => variable_get('confident_captcha_grid_width', 3),
    '#description' => t('Width of the Confident CAPTCHA in images. Width multiplied by height may not exceed 16.'),
  );

  $form['confident_captcha_theme_settings']['confident_captcha_captcha_length'] = array(
    '#type' => 'textfield',
    '#title' => t('Solve Length'),
    '#maxlength' => 1,
    '#default_value' => variable_get('confident_captcha_captcha_length', 4),
    '#description' => t('Number of categories that must be entered to solve the Confident CAPTCHA.'),
  );

  $form['confident_captcha_theme_settings']['confident_captcha_display_style'] = array(
    '#type' => 'select',
    '#title' => t('Display Style'),
	'#options' => array('flyout' => t('Flyout'), 'lightbox' => t('Lightbox')),
    '#default_value' => variable_get('confident_captcha_display_style', 'flyout'),
    '#description' => t('Indicates the UI style the Confident CAPTCHA uses.'),
  );

    $form['confident_captcha_theme_settings']['confident_captcha_show_letters'] = array(
        '#type' => 'select',
        '#title' => t('Show Letters'),
        '#default_value' => variable_get('confident_captcha_show_letters', 'FALSE'),
        '#description' => t('Would you like your Confident CAPTCHA to show the letters on each image?'),
        '#options' => array('TRUE' => t('Yes'), 'FALSE' => t('No')),
        '#required' => FALSE,
    );

    $form['confident_captcha_theme_settings']['confident_captcha_noise_level'] = array(
    '#type' => 'select',
    '#title' => t('Noise Level'),
    '#options' => array('0.1' => t('0.1'), '0.2' => t('0.2'), '0.3' => t('0.3'), '0.4' => t('0.4'), '0.5' => t('0.5'), '0.6' => t('0.6'), '0.7' => t('0.7'), '0.8' => t('0.8'), '0.9' => t('0.9')),
    '#default_value' => variable_get('confident_captcha_noise_level', '0.2'),
    '#description' => t('The noise level of the audio readout of this Confident CAPTCHA.'),
    );

  $form['confident_captcha_theme_settings']['confident_captcha_logo_name'] = array(
    '#type' => 'textfield',
    '#title' => t('Logo Name'),
    '#maxlength' => 40,
    '#default_value' => variable_get('confident_captcha_logo_name', ''),
    '#description' => t('Your site logo.'),
  );

  $form['confident_captcha_theme_settings']['confident_captcha_billboard_name'] = array(
    '#type' => 'textfield',
    '#title' => t('Billboard Name'),
    '#maxlength' => 40,
    '#default_value' => variable_get('confident_captcha_billboard_name', ''),
    '#description' => t('Your site banner.'),
  );

  $form['confident_captcha_advanced_options'] = array(
    '#type' => 'fieldset',
    '#title' => t('Advanced Options'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );

  $form['confident_captcha_advanced_options']['confident_captcha_failure_policy'] = array(
    '#type' => 'select',
    '#title' => t('Failure Policy'),
    '#default_value' => variable_get('confident_captcha_failure_policy', 'math'),
    '#description' => t('If for some reason the Confident CAPTCHA API fails, should the user be allowed to continue?'),
    '#options' => array('math' => t('math'), 'open' => t('open'), 'closed' => t('closed')),
    '#required' => TRUE,
  );
  $form['confident_captcha_advanced_options']['confident_captcha_ajax_verify'] = array(
    '#type' => 'select',
    '#title' => t('AJAX Verify'),
    '#default_value' => variable_get('confident_captcha_ajax_verify', 'FALSE'),
    '#description' => t('Would you like your Confident CAPTCHA to be verified before submitting the page? Note: This option will only work if Drupal is installed as the root website on your web server. It cannot be located in a sub folder on your domain.'),
    '#options' => array('TRUE' => t('Yes'), 'FALSE' => t('No')),
    '#required' => TRUE,
  );
  $form['confident_captcha_advanced_options']['confident_captcha_max_tries'] = array(
    '#type' => 'textfield',
    '#title' => t('Max Tries'),
    '#maxlength' => 1,
    '#default_value' => variable_get('confident_captcha_max_tries', '3'),
    '#description' => t('If you chose to use AJAX verification, how many attempts should the user have to solve the Confident CAPTCHA?'),
    '#required' => TRUE,
  );
  return system_settings_form($form);
}


/**
 * The validation on the confident_captcha administration settings
 */
function confident_captcha_admin_settings_validate($form, &$form_state) {
  // Validate captcha length
  $len = $form_state['values']['confident_captcha_captcha_length'];
  if (!is_numeric($len)) {
    form_set_error('confident_captcha_captcha_length', t('Length must be an integer.'));
  } else if($len > 16) {
    form_set_error('confident_captcha_captcha_length', t('Length must be 16 or less'));
  }
  // Validate grid height
  $height = $form_state['values']['confident_captcha_grid_height'];
  if (!is_numeric($height)) {
    form_set_error('confident_captcha_grid_height', t('Height must be an integer.'));
  } else{
    $width = $form_state['values']['confident_captcha_grid_width'];
    $len = $form_state['values']['confident_captcha_captcha_length'];
    if(is_numeric($width) && is_numeric($len)){
        if($width * $height < $len){
            form_set_error('confident_captcha_grid_height', t('Height * Width must be greater than or equal to Captcha Length'));
        }
    }
  }

  // Validate grid width
  $width = $form_state['values']['confident_captcha_grid_width'];
  if (!is_numeric($width)) {
    form_set_error('confident_captcha_grid_width', t('Width must be an integer.'));
  } else{
      $height = $form_state['values']['confident_captcha_grid_height'];
      $len = $form_state['values']['confident_captcha_captcha_length'];
      if(is_numeric($height) && is_numeric($len)){
          if($width * $height < $len){
              form_set_error('confident_captcha_grid_width');
          }
      }
  }

  //Validate the size of the Confident CAPTCHA
  if (($form_state['values']['confident_captcha_grid_width'] * $form_state['values']['confident_captcha_grid_height']) > 16) {
    form_set_error('confident_captcha_grid_width');
    form_set_error('confident_captcha_grid_height');
    drupal_set_message(t('Width multiplied by height may not exceed 16.'), 'error');
  }

  //Validate the maximum number of tries for an AJAX verified CAPTCHA
  $max_tries = $form_state['values']['confident_captcha_max_tries'];
  if(!is_numeric($max_tries)){
      form_set_error('confident_captcha_max_tries', t('Max Tries must be an integer.'));
  }

  else if (!($max_tries > 0 && $max_tries <= 5)){
      form_set_error('confident_captcha_max_tries', t('Max Tries must be greater than zero and less than or equal to 5.'));
  }
}